# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from image_detector.models.base_model_ import Model
from image_detector import util


class ApiError(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, code: int=None, message: str=None):
        """ApiError - a model defined in OpenAPI

        :param code: The code of this ApiError.
        :param message: The message of this ApiError.
        """
        self.openapi_types = {
            'code': int,
            'message': str
        }

        self.attribute_map = {
            'code': 'code',
            'message': 'message'
        }

        self._code = code
        self._message = message

    @classmethod
    def from_dict(cls, dikt: dict) -> 'ApiError':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The ApiError of this ApiError.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def code(self):
        """Gets the code of this ApiError.


        :return: The code of this ApiError.
        :rtype: int
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this ApiError.


        :param code: The code of this ApiError.
        :type code: int
        """
        if code is None:
            raise ValueError("Invalid value for `code`, must not be `None`")

        self._code = code

    @property
    def message(self):
        """Gets the message of this ApiError.


        :return: The message of this ApiError.
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this ApiError.


        :param message: The message of this ApiError.
        :type message: str
        """
        if message is None:
            raise ValueError("Invalid value for `message`, must not be `None`")

        self._message = message
